summaryrefslogtreecommitdiffstats
path: root/chromium-widevine-plugin
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2014-08-31 18:49:18 +0000
committer Eric Hameleers <alien@slackware.com>2014-08-31 18:49:18 +0000
commit066db8063c6a199192d0089d83539757158b25d8 (patch)
treef98e58e6250b2cbccdf3fd7546b119151df8c9a9 /chromium-widevine-plugin
parentdc7e22c1f9e8b4147210071a05ac655aba35139d (diff)
downloadasb-066db8063c6a199192d0089d83539757158b25d8.tar.gz
asb-066db8063c6a199192d0089d83539757158b25d8.tar.xz
Initial revision
Diffstat (limited to 'chromium-widevine-plugin')
-rwxr-xr-xchromium-widevine-plugin/build/chromium-widevine-plugin.SlackBuild188
-rw-r--r--chromium-widevine-plugin/build/doinst.sh16
-rw-r--r--chromium-widevine-plugin/build/slack-desc19
3 files changed, 223 insertions, 0 deletions
diff --git a/chromium-widevine-plugin/build/chromium-widevine-plugin.SlackBuild b/chromium-widevine-plugin/build/chromium-widevine-plugin.SlackBuild
new file mode 100755
index 00000000..4cf42720
--- /dev/null
+++ b/chromium-widevine-plugin/build/chromium-widevine-plugin.SlackBuild
@@ -0,0 +1,188 @@
+#!/bin/sh
+# $Id$
+# Copyright 2014 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: chromium-widevine-plugin
+# Descr: Google Chrome's Pepper Widevine plugin for Chromium
+# URL: http://www.google.com/chrome
+# Build needs:
+# Needs:
+# Changelog:
+# 1.4.4.637-1: 31/aug/2014 by Eric Hameleers <alien@slackware.com>
+# * Initial release.
+#
+# Run 'sh chromium-widevine-plugin.SlackBuild' to build a Slackware package.
+# The package (.txz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# The version of this package will be determined later by examining the
+# extracted library file.
+
+PRGNAM=chromium-widevine-plugin
+BUILD=${BUILD:-1}
+TAG=${TAG:-alien}
+
+# What is the Chrome version we extract this from?
+CHANNEL=${CHANNEL:-"stable"}
+CHROMEVER=${CHROMEVER:-"37.0.2062.94"}
+RPMSUB=${RPMSUB:-"-1"}
+
+# Version of this plugin - needs to be retrieved by actually running Chrome
+# and checking "chrome://plugins"
+VERSION=${VERSION:-"1.4.4.637"}
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+DOCS="$SRCDIR/license.html"
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Automatically determine the architecture we're building on:
+MARCH=${ARCH:-$( uname -m )}
+case "$MARCH" in
+ x86_64)
+ LIBDIRSUFFIX="64"
+ ARCHBITS="64"
+ export ARCH=x86_64
+ ;;
+ i?86)
+ LIBDIRSUFFIX=""
+ ARCHBITS="32"
+ export ARCH=i386
+ ;;
+ *)
+ echo "Unsupported architecture '$ARCH'"
+ exit 1
+ ;;
+esac
+
+SOURCE[0]="$SRCDIR/google-chrome-$CHANNEL-$CHROMEVER$RPMSUB.$ARCH.rpm"
+SRCURL[0]="https://dl.google.com/linux/chrome/rpm/stable/$ARCH/google-chrome-$CHANNEL-$CHROMEVER$RPMSUB.$ARCH.rpm"
+
+SOURCE[1]="$SRCDIR/license.html"
+SRCURL[1]="http://www.google.com/chrome/intl/en/eula_text.html"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${SOURCE[$i]} ]; then
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ wget -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+rpm2cpio ${SOURCE[0]} | cpio -idmv -R root:root \
+ ./opt/google/chrome/libwidevine*
+chmod -R u+w,go+r-w,a+X-s .
+
+echo "++"
+echo "Version '$VERSION' used for for libpwidevinecdmadapter.so"
+echo "++"
+
+# Move the extracted files over to the package location:
+install -d $PKG/usr/lib${LIBDIRSUFFIX}/Pepper
+install -m0644 opt/google/chrome/libwidevine* \
+ $PKG/usr/lib${LIBDIRSUFFIX}/Pepper/
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Add a package description and post-install script:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/doinst.sh | sed \
+ -e "s/@PRGNAM@/${PRGNAM}/g" \
+ -e "s/@LIBDIRSUFFIX@/${LIBDIRSUFFIX}/g" \
+ -e "s/@PEPVER@/${VERSION}/g" \
+ > $PKG/install/doinst.sh
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/chromium-widevine-plugin/build/doinst.sh b/chromium-widevine-plugin/build/doinst.sh
new file mode 100644
index 00000000..ccbeb895
--- /dev/null
+++ b/chromium-widevine-plugin/build/doinst.sh
@@ -0,0 +1,16 @@
+# Make sure that Chromium finds the new plugin:
+if ! grep -q "START @PRGNAM@" etc/default/chromium 2>/dev/null ; then
+ mkdir -p etc/default
+ cat <<EOT >> etc/default/chromium
+
+# START @PRGNAM@
+if [ -f /usr/lib@LIBDIRSUFFIX@/Pepper/libwidevinecdmadapter.so ]
+then
+ CHROMIUM_FLAGS="\$CHROMIUM_FLAGS --register-pepper-plugins="/usr/lib@LIBDIRSUFFIX@/Pepper/libwidevinecdmadapter.so#Widevine Content Decryption Module#Enables Widevine licenses for playback of HTML audio/video content#@PEPVER@;application/x-ppapi-widevine-cdm"
+fi
+# END @PRGNAM@
+
+EOT
+
+fi
+
diff --git a/chromium-widevine-plugin/build/slack-desc b/chromium-widevine-plugin/build/slack-desc
new file mode 100644
index 00000000..c1950bb3
--- /dev/null
+++ b/chromium-widevine-plugin/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+chromium-widevine-plugin: chromium-widevine-plugin (Widevine plugin for Chromium)
+chromium-widevine-plugin:
+chromium-widevine-plugin: This package contains Google Chrome's Widevine DRM
+chromium-widevine-plugin: plugin for Chromium (stable version).
+chromium-widevine-plugin: Widevine Content Decryption Module enables Widevine
+chromium-widevine-plugin: licenses for playback of HTML audio/video content.
+chromium-widevine-plugin: The library is extracted from a Google Chrome RPM.
+chromium-widevine-plugin: You will have to accept the bundled license file
+chromium-widevine-plugin: if you want to use this closed-source plugin.
+chromium-widevine-plugin:
+chromium-widevine-plugin: chromium-widevine-plugin home: http://www.google.com/chrome